#1. We construct a spread of PG(3,q) as desired.
q := 3;
pg1 := PG(1,q^2);
em := NaturalEmbeddingByFieldReduction(pg1,GF(3));
regular_spread := List(Points(pg1),x->x^em);

l1 := regular_spread[1];
l2 := regular_spread[2];
l3 := regular_spread[3];
opposite_regulus := List(Points(l1),x->Span(x,Meet(Span(x,l2),l3)));
m1 := opposite_regulus[1];
regulus := Filtered(regular_spread,x->ProjectiveDimension(Meet(m1,x))=0);
left_over := Filtered(regular_spread,x->ProjectiveDimension(Meet(m1,x))=-1);
spread := Union(left_over,opposite_regulus);

#2. Check that the spread is really different than the regular spread
pg3 := PG(3,q);
autpg3 := CollineationGroup(pg3);
autspread := FiningSetwiseStabiliser(autpg3,spread);
Order(autspread);
autregularspread := FiningSetwiseStabiliser(autpg3,regular_spread);
Order(autregularspread);

#3. Time to construct the Hall plane
pg4 := PG(4,q);
pi_inf := HyperplaneByDualCoordinates(pg4,[1,0,0,0,0]*Z(q)^0);
em2 := NaturalEmbeddingBySubspace(pg3,pg4,pi_inf);
points1 := Difference(Points(pg4),Points(pi_inf));;
Length(points1);
points2 := List(spread,x->x^em2);;
linesa := Union(List(points2,x->Filtered(Planes(x),y->not y in pi_inf)));;
linesb := [pi_inf];
pts := Union(points1,points2);;
lines := Union(linesa,linesb);;
Length(pts);
Length(lines);
stab := FiningSetwiseStabiliser(CollineationGroup(pg4),points2);
inc := \*;
gp := GeneralisedPolygonByElements(pts,lines,inc,stab,\^);

#4. Compute the collineation group of the Hall plane. 
graph := IncidenceGraph(gp);
digraph := Digraph(graph);
aut := AutomorphismGroup(digraph);
#compare with PGammaL(2,9);
Order(CollineationGroup(PG(2,9)));
graph2 := IncidenceGraph(PG(2,9));
digraph2 := Digraph(graph2);
aut2 := AutomorphismGroup(digraph2);
