#1. set up points and tangent_lines
q := 8;
pg3 := PG(3,q);
quadric := EllipticQuadric(3,q);
ovoid := List(Points(quadric));;
tangent_lines := Set(Filtered(Lines(pg3),x->Number(ovoid,y->y in x)=1));;
pts := Set(List(Points(pg3)));;

#2 set up vertices and adjacency.
vertices := Union(pts,tangent_lines);
stab := CollineationGroup(quadric);

adj := function(x,y)
if x<>y then return x*y;
else return false;
fi;
end;

inc_graph := Graph(stab,vertices,OnProjSubspaces,adj,true);
Diameter(inc_graph);
Girth(inc_graph);

aut := AutomorphismGroup(inc_graph); #some seconds 
Order(aut);
Order(stab);
#we know that there are (q^2+1)(q+1) points and lines
phi := ActionHomomorphism(aut,[[1..(q^2+1)*(q+1)],[(q^2+1)*(q+1)+1..2*(q^2+1)*(q+1)]],OnSets);
Image(phi);
involution := (1,2);
coset := PreImages(phi,involution);
pol := First(coset,x->Order(x)=2);

#Now we look for absolute points. 
names := VertexNames(inc_graph);
absolute := Filtered([1..(q^2+1)*(q+1)],x->names[x] * names[x^pol]);
ovoid := names{absolute};

lines := List(Lines(pg3));;
ints2 := List(lines,x->Number(Points(x),y->y in ovoid));
Collected(ints2);

psl := SpecialProjectivityGroup(pg3);
stab_ovoid := FiningSetwiseStabiliser(psl,Set(ovoid)); #98 seconds
time;
StructureDescription(stab_ovoid);
