q := 8;
pg := PG(3,q);
matrix := [[0,1,0,0],[-1,0,0,0],[0,0,0,1],[0,0,-1,0]]*Z(q)^0;
pol := PolarityOfProjectiveSpace(matrix,GF(q));

absolute_points := Filtered(Points(pg),x->x*x^pol);
absolute_lines := Filtered(Lines(pg),x->x*x^pol);
vertices := Union(absolute_points,absolute_lines);

collineations := CollineationGroup(pg);
group := FiningSetwiseStabiliser(collineations,absolute_lines);

adj := function(x,y)
if x<>y then return x*y;
else return false;
fi;
end;

inc_graph := Graph(group,vertices,OnProjSubspaces,adj,true);

Diameter(inc_graph);
Girth(inc_graph);

#Check the groups!

aut := AutomorphismGroup(inc_graph);
Order(aut);
Order(group);


gp := GeneralisedPolygonByElements(Set(absolute_points),Set(absolute_lines),\*,group,OnProjSubspaces);
